use iron::method::Method;
use iron::middleware::BeforeMiddleware;
use iron::prelude::*;
use params::{Params, Value};

pub struct RestForm {}

impl RestForm {
    fn method(&self, v: &Value) -> Option<Method> {
        match v {
            Value::String(method_str) => match method_str.as_str() {
                "delete" => Some(Method::Delete),
                _ => None,
            },
            _ => None,
        }
    }
}

impl BeforeMiddleware for RestForm {
    fn before(&self, req: &mut Request) -> IronResult<()> {
        if req.method == Method::Post {
            let method = {
                let params = req.get_ref::<Params>().unwrap();
                params
                    .get("_method")
                    .and_then(|m| self.method(m))
                    .unwrap_or(Method::Post)
            };
            req.method = method;
        }
        Ok(())
    }
}
